      subroutine buildi(lpntn,iprob,value,nvalu,idest)
c**********************************************************************
c                 
c**** This routine constructs the matrix for problem IPROB when direct
c**** methods are used. This routine assumes that only one value has
c**** to be assembled.
c                 
c**********************************************************************
      implicit  none
      include  'MatMan.h'
      integer   iprob,itotv,jtotv,nvalu
      integer   lpntn(*),idest(2)
      integer
     .  p_maf(mprob),p_map(mprob),p_lpo(mprob),
     .  p_apc(mprob),p_rof(mprob)                           ! pointer
      real*8    value
      save      p_maf,p_map,p_lpo,p_apc,p_rof 
c
c*** Case of prescribed or condensed degree of freedom
c
      itotv=idest(1)
      jtotv=idest(2)
      if((lpntn(itotv).le.0).or.(lpntn(jtotv).eq.0)) return
c
c*** Initializations
c
      if(kmadi(iprob).gt.0) then
        call spoias(%val(ialpo+(iprob-1)*lengp),p_lpo(iprob))
        call spoias(%val(iamat+(iprob-1)*lengp),p_maf(iprob))
        call svecze(kmadi(iprob),%val(p_maf(iprob)))
        call spoias(%val(iapma+(iprob-1)*lengp),p_map(iprob))
        call spoias(%val(iapii+(iprob-1)*lengp),p_rof(iprob))
        call spoias(%val(iapij+(iprob-1)*lengp),p_apc(iprob))
        if(p_map(iprob).ne.0)
     .    call svecze(nzecp(iprob),%val(p_map(iprob)))
        kmadi(iprob)=-kmadi(iprob)
      end if
c
c*** Coefficient of matrix A_p
c        
      if(lpntn(jtotv).lt.0) then
        if(p_map(iprob).ne.0) then
          call macoam(value,itotv,jtotv,nzecp(iprob),
     .      %val(p_rof(iprob)),%val(p_apc(iprob)),
     .      %val(p_map(iprob)))
        end if
c
c*** Coefficient of the system matrix
c
      else if(lpntn(jtotv).gt.0) then
c
c*** Band matrix storage
c
        if(kmsip(iprob).eq.0) then
          call macoba(value,lpntn(itotv),lpntn(jtotv),nband(iprob),      
     .                %val(p_maf(iprob)),ksymm(iprob))
c
c*** Profile matrix storage
c
        else if(kmsip(iprob).eq.1) then
          call macopr(value,lpntn(itotv),lpntn(jtotv),
     .      %val(p_maf(iprob)),%val(p_lpo(iprob)),
     .      nequa(iprob),ksymm(iprob))
c
c*** Sparse matrix storage
c
        else if(kmsip(iprob).eq.2) then
          call macoba(value,lpntn(itotv),lpntn(jtotv),
     .      nband(iprob),%val(p_maf(iprob)),ksymm(iprob))
c
c*** If a real sparse matrix storage is to be used (thus complicating the
c*** process of the assembly) the routine that must be called to construct
c*** the matrix is MACOSP. The call is as follows
c     
c         call macosp(value,lpntn(itotv),lpntn(jtotv),%val(p_maf),
c    .                %val(incol(iprob)),%val(inrow(iprob)),nonze(iprob))
        end if
      end if
      
      end
