      subroutine spamat(lpntn,iprob,value,nvalu,idest)
c**********************************************************************
c                 
c**** This routine constructs the matrix for problem IPROB when it is
c**** a sparse matrix and an iterative solver is used (SOFAM = 3). This
c**** routine assumes that only one value has to be assembled.
c                 
c**********************************************************************
      implicit  none
      include  'MatMan.h'
      integer   iprob,itotv,jtotv,nvalu,itotn,jtotn
      integer   lpntn(*),idest(2)
      integer   p_mat,p_apc,p_rof                           ! pointer
      real*8    value
c
c*** Initializations
c
      itotv=idest(1)
      jtotv=idest(2)
      if(kmadi(iprob).gt.0) then
        call spoias(%val(iamat+(iprob-1)*lengp),p_mat)
        call svecze(nzecf(iprob),%val(p_mat))
        call spoias(%val(iapma+(iprob-1)*lengp),p_mat)
        if(p_mat.ne.0) call svecze(nzecp(iprob),%val(p_mat))
        kmadi(iprob)=-kmadi(iprob)
      end if
c
c*** Case of prescribed or condensed degree of freedom
c
      if((lpntn(itotv).le.0).or.(lpntn(jtotv).eq.0)) then
        return
c
c*** Coefficient of matrix A_p
c        
      else if(lpntn(jtotv).lt.0) then
        call spoias(%val(iapma+(iprob-1)*lengp),p_mat)
        if(p_mat.ne.0) then
          call spoias(%val(iapii+(iprob-1)*lengp),p_rof)
          call spoias(%val(iapij+(iprob-1)*lengp),p_apc)
          call macoam(value,itotv,jtotv,nzecp(iprob),
     .                %val(p_rof),%val(p_apc),%val(p_mat))
        end if
c
c*** Coefficient of the system matrix
c
      else if(lpntn(jtotv).gt.0) then
        itotn=lpntn(itotv)
        jtotn=lpntn(jtotv)
        call spoias(%val(iamat+(iprob-1)*lengp),p_mat)
        call spoias(%val(iafii+(iprob-1)*lengp),p_rof)
        call spoias(%val(iafij+(iprob-1)*lengp),p_apc)
        call macoam(value,itotn,jtotn,nzecf(iprob),
     .              %val(p_rof),%val(p_apc),%val(p_mat))
      end if
      
      end
