      subroutine asbddd(nequa,nsban,amatr,cmatr,nsist,bvect,
     .                  xvect,iflag,lunit)
c****************************************************************************
c
c*** This routine solves a linear system  A x = b using the Cholesky
c*** decomposition and a forward and a backward substitution. 
c
c    nequa: number of equations
c    nsban: half bandwidth
c    amatr: matrix of the system, assumed to be symmetric and  positive-
c           definite, stored by rows (amatr(nsban+1,nequa))
c    cmatr: working space (decomposition of amatr, cmatr(nsban+1,nequa)
c    nsist: number of different right-hand-sides
c    bvect: right-hand-side
c    xvect: unknown
c    iflag: decomposition is needed (=1) or not (=0)
c    lunit: logical unit to print errors
c
c***************************************************************************
      implicit real*8(a-h,o-z)
      real*8  amatr(nsban+1,nequa),bvect(nequa,nsist),
     .        cmatr(nsban+1,nequa),xvect(nequa,nsist)

      if(iflag.eq.1)
     .  call chobde(nequa,nsban,amatr,cmatr,lunit)           !Cholesky decom.
      call fosbsu(nequa,nsban,cmatr,nsist,bvect,xvect,lunit) !forward subst.
      call basbsu(nequa,nsban,cmatr,nsist,xvect,xvect,lunit) !backward subst.

      end
