      subroutine basbsu(n,l,c,m,z,x,iu)
c****************************************************************************
c
c*** This routine performs a backward substitution to solve the system `Cx=z',
c*** `n' being the number of equations, `l' half the bandwidth,`m' the number
c*** of substitutions to be performed and `iu' the logical unit where errors
c*** have to be printed
c
c****************************************************************************
      implicit real*8(a-h,o-z)
      real*8  c(l+1,n),z(n,m),x(n,m)

      do is = 1,m
        x(n,is) = z(n,is)/c(1,n)
        do i = n-1,1,-1
          x(i,is) = z(i,is)
          k2 = i+l
          if (k2.gt.n) k2 = n
          if (i+1.le.k2) then 
            do k = i+1,k2
              x(i,is) = x(i,is)-c(k-i+1,i)*x(k,is)
            end do
          end if
          if (c(1,i).le.0.) 
     .    call srunen('BASBSU: NON-POSITIVE DEFINITE MATRIX',iu)
          x(i,is) = x(i,is)/c(1,i)
        end do
      end do
 
      return
      end
