      subroutine chobde(n,l,a,c,iu)
c****************************************************************************
c
c*** This routine performs the cholesky decomposition of a matrix `A'
c*** of bandwidth `l' and `n' rows. The resulting matrix is  `C'. Errors
c*** are printed in unit `iu'
c
c****************************************************************************
      implicit real*8(a-h,o-z)
      real*8  a(l+1,n),c(l+1,n)

      do i = 1,n
        c(1,i) = a(1,i)
        k1 = i-l
        if (k1.lt.1) k1 = 1
        if (k1.le.i-1) then 
          do k = k1,i-1
            c(1,i) = c(1,i) - c(i-k+1,k)*c(i-k+1,k)
          end do
        end if
        if (c(1,i).le.0.) 
     .  call srunen('CHOBDE: NON-POSITIVE DEFINITE MATRIX',iu)
        c(1,i) = sqrt(c(1,i))
        j2 = i + l
        if (j2.gt.n) j2 = n
        if (i+1.le.j2) then 
          do j = i+1,j2
            c(j-i+1,i) = a(j-i+1,i)
            k1 = j - l
            if (k1.lt.1) k1 = 1
            if (k1.le.i-1) then 
              do k = k1,i-1
                c(j-i+1,i) = c(j-i+1,i) - c(i-k+1,k)*c(j-k+1,k)
              end do
            end if
            c(j-i+1,i) = c(j-i+1,i)/c(1,i)
          end do
        end if
      end do

      end
