      subroutine fosbsu(n,l,c,m,b,z,iu)
c****************************************************************************
c
c*** This routine performs a forward substitution to solve the system `Cz=b',
c*** `n' being the number of equations, `l' half the bandwidth, `m' the number
c*** of substitutions to be performed and `iu' the logical unit where errors
c*** have to be printed.
c
c****************************************************************************
      implicit real*8(a-h,o-z)
      real*8 c(l+1,n),b(n,m),z(n,m)

      do is = 1,m
        z(1,is) = b(1,is)/c(1,1)
        do i = 2,n
          z(i,is) = b(i,is)
          k1 = i-l
          if (k1.lt.1) k1 = 1
          if (k1.le.i-1) then 
            do k = k1,i-1
              z(i,is) = z(i,is)-c(i-k+1,k)*z(k,is)
            end do
          end if
          if (c(1,i).le.0.) 
     .    call srunen('FOSBSU: NON-POSITIVE DEFINITE MATRIX',iu)
          z(i,is) = z(i,is)/c(1,i)
        end do
      end do

      end
