      subroutine skydia(gstlo,gstup,gstdi,nterm,isymm,pivot)
c***********************************************************************
c
c*** This routine diagonalizes element in triangular decomposition
c
c.... input parameters
c         gstup(nterm) - column of upper triangular part of matrix
c         gstlo(nterm) - row of lower triangular part of matrix
c         gstdi(nterm) - reciprocal of diagonals in triangular factors
c         nterm        - number of terms in vectors
c         isymm        - if 0 -> equations are unsymmetric
c                        if 1 -> equations are symmetric
c         pivot        - diagonal in matrix to be factored
c
c.... output parameter
c         pivot        - reduced diagonal of factor
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      dimension gstlo(*),gstup(*),gstdi(*)
c
c      <<<<<<<<<<<<<<<<<<<<< cute trick to avoid convex error
c
      if(isymm.eq.0) then
        do 100 iterm= 1,nterm
        pivot=pivot-gstlo(iterm)*gstup(iterm)*gstdi(iterm)
        gstup(iterm)=gstup(iterm)*gstdi(iterm)
  100   continue
      else if(isymm.eq.1) then
        do 105 iterm= 1,nterm
        pivot=pivot-gstup(iterm)*gstup(iterm)*gstdi(iterm)
        gstup(iterm)=gstup(iterm)*gstdi(iterm)
  105   continue
      endif
c
c***finish computation of column of gstlo for unsymmetric matrices
c
      if(isymm.eq.0) then
        do 200 iterm=1,nterm
  200   gstlo(iterm)=gstlo(iterm)*gstdi(iterm)
      endif

      return
      end
