      subroutine skylin(neqns,amatr,bvect,lpont,nsist,ksymm,
     .                  kfact,lures)
c****************************************************************************
c
c*** This routine solves a linear system  A x = b using the Skyline
c*** solver
c
c    neqns: number of equations
c    amatr: matrix of the system (GSTDI, GSTUP, GSTLO) see skygra.f
c    nsist: number of different right-hand-sides
c    bvect: right-hand-side
c
c***************************************************************************
      implicit real*8(a-h,o-z)
      integer   lures,kfact
      integer   lpont(neqns)
      real*8    amatr(*),    bvect(neqns,nsist)

      igstd=1                            ! GSTDI(NEQNS)
      igstu=igstd+neqns                  ! GSTUP(LPONT(NEQNS))
      igstl=igstu+ksymm*lpont(neqns)     ! GSTLO(LPONT(NEQNS))
      call skyli0(neqns,amatr(igstd),amatr(igstu),
     .            amatr(igstl),bvect,lpont,nsist,ksymm,
     .            kfact,lures)

      end
