      subroutine solsys(
     .  iffix,lnods,rhsid,unkno,ntotv,nelem,nnode,
     .  nnodt,nnodw,ndofn,npoin,nsist,kfact,iprob,
     .  istep,iiter,timei) 
c****************************************************************************
c
c**** This routine drives the library to solve a linear system
c**** of equations. 
c
c****************************************************************************
      implicit none
      include   'MatMan.h'
      integer    ntotv,nelem,nnode,nnodt,nnodw,ndofn,npoin,
     .           nsist,iprob,kfact,iiter,istep
      integer    lnods(nnodt,nelem), iffix(ntotv)
      real*8     rhsid(ntotv,nsist), unkno(ntotv,nsist)
      real*8     elcpu,timei,timef
      logical*1  outso
c
c*** Write titles, if required
c
      outso=.false.
      if(iiter+istep.gt.0) outso=.true.
      if(outso) write(lusol,100) wosol(iprob),iiter,istep
c
c*** Direct to appropriate solver scheme
c      
      if (sofam(iprob).eq.1) then                           ! Direct solvers
        call dirsol(rhsid,unkno,ntotv,nsist,kfact,iprob,
     .              outso)
      else if(sofam(iprob).eq.2) then                       ! EE Iterative solvers
        call ite_ee(iffix,lnods,unkno,rhsid,nnode,nnodt,
     .              nnodw,nelem,ndofn,ntotv,npoin,nsist,
     .              iprob,kfact,outso)
      else if (sofam(iprob).eq.3) then                      ! SK Iterative solvers
        call ite_sk(rhsid,unkno,ntotv,nsist,kfact,iprob,
     .              outso)
      end if
      kmadi(iprob) = abs(kmadi(iprob))                      ! Solution done
      svome(iprob) = 0
      if(outso) then
        call scputi(timef)
        elcpu=timef-timei
        write(lusol,110) elcpu
      end if
c
c*** Formats
c
  100 format(//,5x,67('#'),//,5x,
     .  '>>>> SOLVER INFORMATION FOR:  ',a15,/,5x,
     .  '     ----------------------   ',//,
     .  11x,'*** ITERATION NUM.         : ',i12/,
     .  11x,'*** TIME STEP NUM.         : ',i12)
  110 format(11x,'*** ELAPSED CPU TIME       : ',f12.2)

      end
