      subroutine sparse(nequa,nonze,multi,amatr,lncol,lnrow,bvect,
     .                  nsist,ifail,kfact,lunit,svomt,svome,lengp)
c****************************************************************************
c
c*** This routine solves a linear system  A x = b using
c*** Gaussian elimination. A is stored in a sparse way.
c
c    nequa: number of equations
c    nonze: number of non-zero elements in A
c    multi: multi*nonze is the dimension of amatr
c    amatr: matrix of the system (multi*nonze)
c    lncol: lncol(j) contains number of the column of amatr(j)
c    lnrow: lnrow(j) contains number of the row of amatr(j)
c    bvect: rigth hand side (nequa,nsist)
c    nsist: number of systems to be solved
c    lunit: unity to write errors
c    kfact: (=1) solve, (=0) not solve (only substitution is done)
c
c***************************************************************************
      implicit real*8(a-h,o-z)
      integer  ip                                           ! pointer
      real*8   amatr(multi*nonze), bvect(nequa,nsist)
      integer  lncol(multi*nonze), lnrow(multi*nonze)
      integer  svomt,svome,lengp
      
      iha=nequa+1
      ipoi1=0                                               ! pivot(nequa)
      ipoi2=ipoi1+nequa*8                                   ! ha(iha,11)
      ipoi3=ipoi2+iha*11*lengp                              ! aflag(8)
      ipoi4=ipoi3+8*8                                       ! iflag(10)
      ipoi5=ipoi4+10*lengp
      call sadmem(0,ip,ipoi5,svomt)
      call svecze(ipoi5/8,%val(ip))
      ifail=0
      call y12maf(nequa,nonze,amatr,lncol,multi*nonze,lnrow,
     .            multi*nonze,%val(ip+ipoi1),%val(ip+ipoi2),
     .            iha,%val(ip+ipoi3),%val(ip+ipoi4),bvect,
     .            ifail,kfact,nsist)
      if (ifail.ne.0.and.ifail.ne.5)
     .  call srunen('SPARSE: THE PARAMETER ifail IS NOT 0 OR 5',
     .  lunit)

      svome=max(svome,svomt)
      call sadmem(2,ip,ipoi5,svomt)
      
      end
