c***********************************************************************
c
c*** This file contains the parameters needed for the solver library
c
c***********************************************************************
      integer       mprob          ! maximum number of problems to 
      parameter    (mprob=9)       ! be considered
c
c*** Pointers for the solver
c
      integer         lengp
      common/lenpoin/ lengp
      integer       iamat,         ! addresses for the matrices
     .              incol,         ! address for LNCOL
     .              inrow,         ! address for LNROW
     .              ialpn,         ! address for LPNTN
     .              ialpo,         ! address for LPONT 
     .              iapma,         ! address for matrix A_p
     .              iapii,         ! address for ROFFS of A_p
     .              iapij,         ! address for APCOL of A_p
     .              iafii,         ! address for ROFFS of A_f
     .              iafij,         ! address for APCOL of A_f
     .              irhsx          ! address for RHSAX
      common/poinsoll/ iamat,incol,inrow,ialpn,ialpo,iapma,iapii,
     .                 iapij,iafii,iafij,irhsx
c
c*** Output unit
c
      integer        lusol
      common/outsol/ lusol      
c
c*** Memory for the system matrix (itask=1) 
c
      integer       nband(mprob), ! half-bandwidth
     .              kmsip(mprob), ! Type of matrix storage
     .              ksymm(mprob), ! Symmetric (=0) or Unsymmetric (=1)
     .              nonze(mprob), ! Number of non-zero elements in matrix
     .              nmult(mprob), ! Dimension multiplier for sparse matrix
     .              svome(mprob), ! Volatile memory employed
     .              speme(mprob), ! Permanent memory
     .              nzecp(mprob), ! Non-zero components of matrix A_p
     .              nzecf(mprob), ! Non-zero components of matrix A_f
     .              sizms(mprob)  ! Size of the system matrix for direct solvers
      common/buil/  nband,kmsip,ksymm,nonze,nmult,svome,speme,
     .              nzecp,nzecf,sizms
c
c*** Renumber (itask=2)
c
      integer       nequa(mprob), ! number of equations
     .              krenu(mprob)  ! renumbering required or not
      common/ren/   nequa, krenu
      logical*1     conde(mprob)  ! condensation of bubble nodes
      common/renl/  conde
c
c*** Iterative solvers
c
      integer       kites(mprob), ! type of iterative solver
     .              itmax(mprob), ! maximum number of iterations
     .              kkryl(mprob), ! Krylov subspace for GMRES
     .              lfill(mprob)  ! Fill-in for ILUT 
      common/iter/  kites, itmax, kkryl, lfill
      real*8        toler(mprob), ! tolerance for convergency
     .              thres(mprob)  ! Threshold for ILUT
      common/rite/  toler,thres
      character*15  wosol(mprob)
      common/cite/  wosol
c
c*** Othe parameters and flags
c
      real*8        zeroc
      parameter    (zeroc=1.0e-15) ! zero for comparisons
      integer       kmadi(mprob),  ! initialization of matrices
     .              sofam(mprob)   ! solver family
      common/oflag/ kmadi,sofam
