      subroutine conjgr(
     .  lnods,eamat,xvect,bvect,toler,kmaxi,
     .  nnode,nnodt,nnodw,nelem,nequa,ndofn,
     .  npoin,lengp,iffix,lures,svome,svomt,
     .  kprec,outso)
c****************************************************************************
c
c**** This routine solves a linear system of equations by the conjugate 
c**** gradient. A diagonal preconditioning is used.
c
c****************************************************************************
      implicit none
      integer   a,eamat,p_mat                               ! pointer
      integer
     .  nnode,nnodt,nnodw,nelem,nequa,nevaw,ndofn,npoin,
     .  npois,ielem,adiag,r_k_1,p_k  ,z_k_1,lengp,w_k  ,
     .  elpve,elwve,lbyts,ndimt,kmaxi,lures,svome,
     .  svomt,kprec
      integer   lnods(nnodt,nelem),iffix(nequa)
      real*8    toler
      real*8    xvect(nequa),       bvect(nequa)
      logical*1 outso
      integer   lbyta
      data      lbyta/0/
      save      lbyta,a
c
c*** Auxiliar memory pointers
c      
      npois=nequa-npoin*ndofn
      nevaw=nnode*ndofn+nnodw-nnode
      adiag=0   
      r_k_1=adiag+nequa*8
      p_k  =r_k_1+nequa*8
      z_k_1=p_k  +nequa*8
      w_k  =z_k_1+nequa*8
      elpve=w_k  +nequa*8
      elwve=elpve+nevaw*8
      lbyts=elwve+nevaw*8
c
c*** Allocate memory and initialize auxiliar memory
c
      if (lbyta.eq.0) then
        call sadmem(0,a,lbyts,svomt)
        lbyta=lbyts
      else
        if (lbyts.gt.lbyta) then
          svome=max(svome,svomt)
          call sadmem(2,a,lbyta,svomt)
          call sadmem(0,a,lbyts,svomt)
          lbyta=lbyts
        end if
      end if
      ndimt=lbyts/8 
      call svecze(ndimt,%val(a)) 
c
c*** Assembly of the diagonal, if needed
c
      if(kprec.eq.-1) then                                  ! No precond.
        call svecpu(1.0,nequa,%val(a+adiag))
      else if(kprec.eq.-2) then                             ! Diagonal precond.
        do ielem=1,nelem
          call spoias(%val(eamat+(ielem-1)*lengp),p_mat)
          call assdia(lnods(1,ielem),%val(p_mat),       
     .      %val(a+adiag),nnode,nnodt,nnodw,nevaw,
     .      ndofn,npoin,npois,nequa,0)
        end do
      end if
c
c*** Solve the algebraic system using the preconditionned conjugate
c*** gradient method      
c
      call cgprec(lnods,eamat,lengp,%val(a+adiag),xvect,   
     .            bvect,toler,kmaxi,                       
     .            %val(a+r_k_1),%val(a+p_k),%val(a+z_k_1), 
     .            %val(a+w_k),%val(a+elpve),%val(a+elwve),
     .            nnode,nnodt,nnodw,nelem,nequa,nevaw,ndofn,
     .            npoin,npois,iffix,lures,outso)

      end
