      subroutine elmodi(iffix,lnods,elmat,preel,rhsid,forel,
     .  nnode,nnodw,ndofn,nevat,npoin,ntotv,
     .  ksymm,zeroc,iflag)
c*****************************************************************************
c
c**** This routine computes the contribution to the RHS of the Dirichlet
c**** conditions and modifies the element matrices to account for them      
c
c*****************************************************************************
      implicit none
      integer    nnode,nnodw,ndofn,nevat,npoin,ntotv,ksymm,
     .  ievat,kevat,inode,ipoin,itott,idofn,ipos1,
     .  ipos2,iflag
      integer    lnods(nnodw),   iffix(ntotv)
      real*8     zeroc,adiag,adiao
      real*8     elmat(nevat*nevat),   preel(nevat),
     .  rhsid(ntotv)      ,   forel(nevat)
c
c*** Multiply A^e x^e, where x^e contains the prescribed d.o.f.
c
      if(iflag.eq.1) call elmbve(elmat,preel,forel,nevat,ksymm)
c
c*** Prescribe all the Dirichlet conditions by modifying the element
c*** matrices and RHS
c
      ievat=0
      adiao=1.0d0
      do inode=1,nnode                                      ! Main nodes
        ipoin=lnods(inode)
        if(ipoin.ne.0) then
          itott=(ipoin-1)*ndofn
          do idofn=1,ndofn
            itott=itott+1
            ievat=ievat+1
            if(iffix(itott).eq.1) then
              if(ksymm.eq.0) then
                ipos1=(ievat-1)*nevat-(ievat-1)*(ievat-2)/2+1
                adiag=elmat(ipos1)
                if(abs(adiag).lt.zeroc) adiag=adiao
                adiao=adiag
                elmat(ipos1)=adiag
                do kevat=ievat+1,nevat
                  ipos1=ipos1+1
                  elmat(ipos1)=0.0d0
                end do
                do kevat=1,ievat-1
                  ipos1=(kevat-1)*nevat-(kevat-1)*(kevat-2)/2
     .              +ievat-kevat+1
                  elmat(ipos1)=0.0d0
                end do
              else if(ksymm.eq.1) then
                ipos1=(ievat-1)*nevat+ievat
                adiag=elmat(ipos1)
                if(abs(adiag).lt.zeroc) adiag=adiao
                adiao=adiag
                do kevat=1,nevat
                  ipos1=(kevat-1)*nevat+ievat
                  ipos2=(ievat-1)*nevat+kevat
                  elmat(ipos1)=0.0d0
                  elmat(ipos2)=0.0d0
                end do
                ipos1=(ievat-1)*nevat+ievat
                elmat(ipos1)=adiag
              end if
              if(iflag.eq.1) forel(ievat)=-adiag*preel(ievat)
            end if
          end do
        end if
      end do
      
      adiao=1.0d0
      do inode=nnode+1,nnodw                                ! Secondary nodes
        ipoin=lnods(inode)
        if(ipoin.ne.0) then
          itott=npoin*ndofn+ipoin-npoin
          ievat=nnode*ndofn+inode-nnode
          if(iffix(itott).eq.1) then
            if(ksymm.eq.0) then
              ipos1=(ievat-1)*nevat-(ievat-1)*(ievat-2)/2+1
              adiag=elmat(ipos1)
              if(abs(adiag).lt.zeroc) adiag=adiao
              adiao=adiag
              elmat(ipos1)=adiag
              do kevat=ievat+1,nevat
                ipos1=ipos1+1
                elmat(ipos1)=0.0d0
              end do
              do kevat=1,ievat-1
                ipos1=(kevat-1)*nevat-(kevat-1)*(kevat-2)/2
     .            +ievat-kevat+1
                elmat(ipos1)=0.0d0
              end do
            else if(ksymm.eq.1) then
              ipos1=(ievat-1)*nevat+ievat
              adiag=elmat(ipos1)
              if(abs(adiag).lt.zeroc) adiag=adiao
              adiao=adiag
              do kevat=1,nevat
                ipos1=(kevat-1)*nevat+ievat
                ipos2=(ievat-1)*nevat+kevat
                elmat(ipos1)=0.0d0
                elmat(ipos2)=0.0d0
              end do
              ipos1=(ievat-1)*nevat+ievat
              elmat(ipos1)=adiag
            end if
            if(iflag.eq.1) forel(ievat)=-adiag*preel(ievat)
          end if
        end if
      end do
      
      end
