      subroutine gmress(eamat,nequa,bvect,xvect,toler,kmaxi,nkryl,
     .                  lnods,nnode,nnodt,nnodw,nelem,ndofn,npoin,
     .                  ksymm,lengp,iffix,lures,svome,svomt,kprec,
     .                  outso)
c*************************************************************************
c      
c**** Solves non-symmetric linear systems of equations by the precon- 
c**** ditioned GMRES method
c      
c*************************************************************************  
      implicit none
      integer    a,eamat,p_mat,p_wo1                        ! pointer
      integer    nnode,nnodt,nnodw,nevaw,ndofn,npoin,npois,
     .           ksymm,nelem,lures,nequa,kmaxi,nkryl,lengp, 
     .           ielem,adiag,elpve,elwve,work2,lbyts,ndimt,
     .           nwor2,svome,kprec,svomt,iprin,lbypw
      integer    lnods(nnodt,nelem), iffix(nequa)
      real*8     bvect(nequa),  xvect(nequa)
      real*8     toler
      logical*1  outso
      integer    lbyta,lbypa
      data       lbyta,lbypa/0,0/
      save       lbyta,lbypa,a,p_wo1
c
c*** Initializations
c
      iprin=0
      if(outso) iprin=2
c
c*** Auxiliar memory pointers
c      
      npois=nequa-npoin*ndofn
      nevaw=nnode*ndofn+nnodw-nnode
      nwor2=(nkryl*(nkryl+1))/2+4*nkryl+2
      adiag=0
      elpve=adiag+nequa*8
      elwve=elpve+nevaw*8
      work2=elwve+nevaw*8
c
c*** Allocate memory ,if it is neccesary, and initialize auxiliar memory
c
      lbyts=work2+nwor2*8
      lbypw=(nkryl+1)*nequa*8
      if (lbyta.eq.0) then                                  !First pass
        call sadmem(0,a,lbyts,svomt)                        !Allocate memory
        lbyta=lbyts
        call sadmem(0,p_wo1,lbypw,svomt)
        lbypa=lbypw
      else
        if (lbyts.gt.lbyta) then
          svome=max(svome,svomt)
          call sadmem(2,a,lbyta,svomt)                      !Deallocate memory
          call sadmem(0,a,lbyts,svomt)                      !Alloc. new memory
          lbyta=lbyts
        end if
        if (lbypw.gt.lbypa) then
          svome=max(svome,svomt)
          call sadmem(2,p_wo1,lbypa,svomt)
          call sadmem(0,p_wo1,lbypw,svomt)
          lbypa=lbypw
        end if
      end if
      ndimt=lbyts/8
      call svecze(ndimt,%val(a))
      call svecze(lbypw/8,%val(p_wo1))
c
c*** Assembly of the diagonal, if needed
c      
      if(kprec.eq.-1) then                                  ! No precond.
        call svecpu(1.0,nequa,%val(a+adiag))
      else if(kprec.eq.-2) then                             ! Diagonal precond.
        do ielem=1,nelem
          call spoias(%val(eamat+(ielem-1)*lengp),p_mat)
          call assdia(lnods(1,ielem),%val(p_mat),          
     .      %val(a+adiag),nnode,nnodt,nnodw,nevaw,
     .      ndofn,npoin,npois,nequa,ksymm)
        end do
      end if
c
c*** Solve the algebraic system using the preconditionned GMRES method
c
      call gmrcor(eamat,lengp,%val(a+adiag),%val(a+work2),
     .            %val(p_wo1),xvect,nequa,nkryl,kmaxi,
     .            toler,bvect,iprin,lnods,%val(a+elpve), 
     .            %val(a+elwve),nevaw,nnode,nnodt,nnodw,
     .            ndofn,npoin,npois,nelem,ksymm,lures,
     .            nwor2,iffix)

      end
