      subroutine gmrsol(h,y,e,idim)
c*************************************************************************
c
c**** This routine solves an upper linear system of the form H Y = E. The
c**** (idim x idim) matrix H and the vector E are data. The result is Y
c
c*************************************************************************
      implicit none
      integer  idim, i, j, lhij, lhii, ly
      real*8   h(*), y(*), e(*)

      do i=1,idim
        ly=idim-i+1
        y(ly)=e(ly)
        do j=ly+1,idim
          lhij=((j-1)*j)/2+ly
          y(ly)=y(ly)-h(lhij)*y(j)
        end do
        lhii=((ly-1)*ly)/2+ly
        y(ly)=y(ly)/h(lhii)
      end do

      end         
