      subroutine iterhs(iffix,lnods,rhsid,rhsax,unkno,preel,
     .                  forel,ntotv,nsist,nnode,nnodt,nnodw,
     .                  ndofn,nevat,nelem,npoin,lengp,eamat,
     .                  ksymm,zeroc) 
c****************************************************************************
c
c**** This routine prescribes the Dirichlet boundary conditions when itera-
c**** tive solvers are used. This is done by substracting to the original
c**** RHS the product A x_p and replacing the equations for the prescribed
c**** d.o.f. by the trivial relations a_ii x_i = a_ii x_i,p (x_i,p: pres-
c**** cribed value, a_ii: diagonal term of A^e)      
c
c****************************************************************************
      implicit none
      integer ntotv,nsist,nnode,nnodt,nnodw,ndofn,nevat,
     .        nelem,npoin,lengp,ksymm,iflag,isist,itotv,
     .        ielem,idofn,itott,ievat,ipoin,inode
      integer eamat,p_mat                                   ! pointer
      integer iffix(ntotv),         lnods(nnodt,nelem)
      real*8  rhsid(nsist,ntotv),   rhsax(nsist,ntotv),
     .        unkno(ntotv,nsist),   preel(nevat),
     .        forel(nevat) 
      real*8  xcomp,zeroc
c
c*** Initialization
c
      call svecze(nsist*ntotv,rhsax)
c
c*** Check if x_p is zero 
c
      do isist=1,nsist
        iflag=0
        do itotv=1,ntotv
          if (iffix(itotv).eq.1) then
            xcomp=unkno(itotv,isist)
            xcomp=xcomp*xcomp
            if(xcomp.gt.zeroc) iflag=1
          end if
        end do
c
c*** Compute the product A x_p and modify the element matrices and RHS
c
        do ielem=1,nelem
          if(iflag.eq.1) then
            call svecze(nevat,preel)
            call svecze(nevat,forel)
            ievat=0
c
c*** Gather of PREEL (prescribed values)
c            
            do inode=1,nnode         
              ipoin=lnods(inode,ielem)
              if(ipoin.ne.0) then
                itott=(ipoin-1)*ndofn
                do idofn=1,ndofn
                  ievat=ievat+1
                  itott=itott+1
                  if(iffix(itott).eq.1)
     .              preel(ievat)=unkno(itott,isist)
                end do
              end if
            end do
            do inode=nnode+1,nnodw
              ipoin=lnods(inode,ielem)
              if(ipoin.ne.0) then
                ievat=ievat+1
                itott=ndofn*npoin+ipoin-npoin
                if(iffix(itott).eq.1)
     .            preel(ievat)=unkno(itott,isist)
              end if
            end do
          end if
c
c*** Calculation of f^e = A^e x^e and modification of A^e
c            
          call spoias(%val(eamat+(ielem-1)*lengp),p_mat)
          call elmodi(iffix,lnods(1,ielem),%val(p_mat),
     .                preel,rhsid,forel,nnode,nnodw,ndofn,
     .                nevat,npoin,ntotv,ksymm,zeroc,iflag)
c
c*** Scatter of f^e
c
          if(iflag.eq.1) then
            ievat=0
            do inode=1,nnode
              ipoin=lnods(inode,ielem)
              if(ipoin.ne.0) then
                itott=(ipoin-1)*ndofn
                do idofn=1,ndofn
                  ievat=ievat+1
                  itott=itott+1
                  rhsax(itott,isist)=rhsax(itott,isist)
     .              -forel(ievat)
                end do
              end if
            end do
            do inode=nnode+1,nnodw
              ipoin=lnods(inode,ielem)
              if(ipoin.ne.0) then
                ievat=ievat+1
                itott=ndofn*npoin+ipoin-npoin
                rhsax(itott,isist)=rhsax(itott,isist)
     .            -forel(ievat)
              end if
            end do
          end if
        end do
      end do

      end
