      subroutine amux (n, x, y, a,ja,ia) 
c*****************************************************************************
c
c         A times a vector
c
c Multiplies a matrix by a vector using the dot product form
c Matrix A is stored in compressed sparse row storage.
c
c on entry:
c ---------
c n     = row dimension of A
c x     = real array of length equal to the column dimension of
c         the A matrix.
c a, ja,
c    ia = input matrix in compressed sparse row format.
c
c on return:
c ----------
c y     = real array of length n, containing the product y=Ax
c
c
c*****************************************************************************
      implicit none
      real*8  x(*), y(*), a(*) 
      integer n, ja(*), ia(*)
      real*8 t
      integer i, k
      
      do i = 1,n
        t = 0.0d0
        do k=ia(i), ia(i+1)-1 
          t = t + a(k)*x(ja(k))
        end do
        y(i) = t
      end do

      end
