      subroutine atmux (n, x, y, a, ja, ia)
c*****************************************************************************
c
c         transp( A ) times a vector
c
c Multiplies the transpose of a matrix by a vector when the original
c matrix is stored in compressed sparse row storage. Can also be
c viewed as the product of a matrix by a vector when the original
c matrix is stored in the compressed sparse column format.
c ----------------------------------------------------------------------
c
c on entry:
c ---------
c n     = row dimension of A
c x     = real array of length equal to the column dimension of
c         the A matrix.
c a, ja,
c    ia = input matrix in compressed sparse row format.
c
c on return:
c ----------
c y     = real array of length n, containing the product y=transp(A)*x
c
c*****************************************************************************
      implicit none
      real*8 x(*), y(*), a(*) 
      integer n, ia(*), ja(*)
      integer i, k 

      do i=1,n
        y(i) = 0.0d0
      end do

      do i = 1,n
        do  k=ia(i), ia(i+1)-1 
          y(ja(k)) = y(ja(k)) + x(i)*a(k)
        end do
      end do
      
      end
