      subroutine auxdri(nrows,ipara,fpara,iters,resit,ounit,amatr,
     .                  jacol,iarow,aumat,jauco,jurow,works,again)
c********************************************************************************
c
c**** This routine performs some auxiliar operations to ITDRIV
c      
c********************************************************************************
      implicit none
      integer   nrows,iters,ounit, 
     .          jacol(*),iarow(*),ipara(*),jauco(*), jurow(*)
      real*8    resit, fpara(*), works(*), amatr(*),aumat(*)
      logical*1 again
c
c*** Convergence can be written by using the following lines:
c      
c     if (ipara(7).ne.iters) then
c       write (ounit, *) iters, real(resit)
c       iters = ipara(7)
c     endif
      resit = fpara(5)
c
c*** Decide what to do depending on ipara(1).
c
      if (ipara(1).eq.1) then
        call amux  (nrows,works(ipara(8)),works(ipara(9)),
     .              amatr,jacol,iarow)
      else if (ipara(1).eq.2) then
        call atmux (nrows,works(ipara(8)),works(ipara(9)),
     .              amatr,jacol,iarow)
      else if (ipara(1).eq.3 .or. ipara(1).eq.5) then
        call lusol (nrows,works(ipara(8)),works(ipara(9)),
     .              aumat,jauco,jurow)
      else if (ipara(1).eq.4 .or. ipara(1).eq.6) then
        call lutsol(nrows,works(ipara(8)),works(ipara(9)),
     .              aumat,jauco,jurow)
      else if (ipara(1).le.0) then
        again = .false. 
        if (ipara(1).eq.0) then
          continue ! Iterative solver has satisfied convergence test
        else if (ipara(1).eq.-1) then
          continue
c-w       write(ounit,*)                                ! This warning may be
c-w  .      '     >>>> WARNING: ITERATIVE SOLVER HAS',  ! written, if wanted
c-w  .      ' ITERATED TOO MANY TIMES <<<< '
        else if (ipara(1).eq.-2) then
          call srunen(
     .      'AUXDRI: ITERATIVE SOLVER WAS NOT GIVEN ENOUGH SPACE.',
     .      ounit)
          call srunei(
     .      'AUXDRI: REQUIRED NUMBER OF ELEMENTS OF THIS SPACE',
     .      ipara(4),ounit)
        else if (ipara(1).eq.-3) then
          call srunen(
     .      'AUXDRI: ITERATIVE SOLVER IS FACING A BREAK-DOWN',ounit)
        else
          call srunei(
     .      'AUXDRI: ITERATIVE SOLVER TERMINATED, CODE = ',
     .      ipara(1),ounit)
        endif
      endif

      end
