      subroutine diapre(
     .  diago,unkno,amatr,roffs,amcol,rhsid,nrows,
     .  ioutp,itask)
c****************************************************************************
c
c**** For ITASK = 1, this routine performs a diagonal scaling of a matrix
c**** A (stored in AMATR) as  A' = D^-1/2 A D^-1/2. The RHS and the initial
c**** guess are also modified. For ITASK = 2, the real unkonwn x = D^-1/2 x'
c**** is computed.
c
c****************************************************************************
      implicit none
      integer
     .  nrows,irows,izeco,jcomp,izecf,jzeco,ioutp,itask
      integer
     .  amcol(*), roffs(nrows)
      real*8
     .  diago(nrows), amatr(*), unkno(nrows), rhsid(nrows)
      real*8
     .  diagt,diaga
c
c***  Obtain the diagonal of the matrix
c
      if(itask.eq.1) then
        do irows = 1,nrows
          izeco = roffs(irows)
          jcomp = amcol(izeco)
          do while(jcomp.ne.irows)
            izeco=izeco+1
            jcomp=amcol(izeco)
          end do
          diagt = amatr(izeco)
          diaga = abs(diagt)
          if(diaga.lt.1.0e-10) then
            call srunei(
     .        'DIAPRE: ZERO DIAGONAL FOR EQUATION',irows,ioutp)
          else
            diago(irows) = 1.0/sqrt(diaga)
          end if
        end do
c
c***  Scaling of A and the RHS and modification of the intial guess
c
        do irows = 1,nrows
          izeco = roffs(irows)
          izecf = roffs(irows+1) - 1
          diagt = diago(irows)
          do jzeco = izeco,izecf
            jcomp = amcol(jzeco)
            amatr(jzeco) = amatr(jzeco)*diagt*diago(jcomp)
          end do
          rhsid(irows) = rhsid(irows)*diagt
          unkno(irows) = unkno(irows)/diagt
        end do
      end if
c
c***  Recovering of the unknown and restoring of A
c
      if(itask.eq.2) then
        do irows = 1,nrows
          izeco = roffs(irows)
          izecf = roffs(irows+1) - 1
          diagt = diago(irows)
          do jzeco = izeco,izecf
            jcomp = amcol(jzeco)
            amatr(jzeco) = amatr(jzeco)/(diagt*diago(jcomp))
          end do
          unkno(irows) = unkno(irows)*diagt
        end do
      end if

      end
