      subroutine ite_sk(
     .  rhsid,unkno,ntotv,nsist,kfact,iprob,outso)
c****************************************************************************
c
c**** This routine drives the library to solve a linear system of equations
c**** by SK iterative methods.
c
c****************************************************************************
      implicit none
      include   'MatMan.h'
      integer
     .  ntotv,nsist,iprob,kfact,iflag,svomt,
     .  lbyta,lbyts,sotyp,ipar(16)
      real*8
     .  rhsid(ntotv,nsist), unkno(ntotv,nsist)
      integer
     .  p_mat,iwoso,p_col,p_lpn,p_rof,p_rhs                 ! pointer
      logical*1   outso
      real*8      fpar(16)
      data        lbyta,svomt/0,0/
      save        lbyta,iwoso,svomt
c
c*** Initializations
c
      call svecze(16,fpar)
      call slvecz(16,ipar)
c
c*** Allocate a work space for the redefinition of RHSID and UNKNO (this
c*** work space is kept)      
c
      lbyts=8*ntotv*nsist
      if (lbyta.eq.0) then
        call sadmem(0,iwoso,lbyts,svomt)
        lbyta=lbyts
      else
        if (lbyts.gt.lbyta) then
          svome(iprob)=max(svome(iprob),svomt)
          call sadmem(2,iwoso,lbyta,svomt)
          call sadmem(0,iwoso,lbyts,svomt)
          lbyta=lbyts
        end if
      end if
      call spoias(%val(ialpn+(iprob-1)*lengp),p_lpn)
c
c*** Compute A_p x_p, where x_p are the prescribed values of the unknown
c*** (MODRHS in DIRMETH)      
c
      iflag=1
      call spoias(%val(iapma+(iprob-1)*lengp),p_mat)
      if(p_mat.eq.0) iflag=0
      call spoias(%val(irhsx+(iprob-1)*lengp),p_rhs)
      if((p_mat.ne.0).and.(kfact.le.1)) then
        call spoias(
     .    %val(iapii+(iprob-1)*lengp),p_rof)
        call spoias(
     .    %val(iapij+(iprob-1)*lengp),p_col)
        call modrhs(
     .    %val(p_lpn),%val(p_rof),%val(p_col),
     .    unkno,%val(p_rhs),%val(p_mat),ntotv,
     .    nzecp(iprob),nsist,nequa(iprob),iflag,
     .    zeroc)
      end if
c
c*** Redefine RHSID and UNKNO according to the renumbering strategy
c*** (REDEFR in DIRMETH). The prescribed values of UNKNO are put in 
c*** its nequa+1,...,ntotv components
c
      if(iflag.eq.0) p_rhs=iwoso ! not used 
      call reduit(
     .  unkno,%val(p_lpn),%val(iwoso),ntotv,nequa(iprob),
     .  nsist,1)
      call redefr(
     .  %val(iwoso),%val(p_lpn),%val(p_rhs),rhsid,ntotv,
     .  nequa(iprob),nsist,iflag)
c
c*** Call the driver for SK iterative solvers
c
      ipar( 2) = kmsip(iprob) - 1
      ipar( 5) = kkryl(iprob)
      ipar( 6) = itmax(iprob)
      ipar(13) = lfill(iprob)
      fpar( 1) = toler(iprob)
      fpar(13) = thres(iprob)
      call spoias(%val(iamat+(iprob-1)*lengp),p_mat)
      call spoias(%val(iafij+(iprob-1)*lengp),p_col)
      call spoias(%val(iafii+(iprob-1)*lengp),p_rof)
      sotyp = kites(iprob) - 30
      call itdriv(
     .  nequa(iprob),nsist,%val(iwoso),unkno,ipar,fpar,
     .  %val(p_mat),%val(p_col),%val(p_rof),sotyp,lusol,
     .  svomt,lengp,8,outso)
c
c*** Redefine UNKNO according to the renumbering strategy
c
      call reduit(
     .  unkno,%val(p_lpn),%val(iwoso),ntotv,nequa(iprob),
     .  nsist,2)
c
c*** Write temporary memory requirements 
c
      svome(iprob)=max(svome(iprob),svomt)
      if(outso) write(lusol,110) svome(iprob)
c
c*** Formats
c
  110 format(11x,'*** VOLATILE MEMORY (BYTES): ',i12)

      end
