      subroutine lutsol (n, y, x, alu, jlu, ju) 
      real*8 x(n), y(n), alu(*)
      integer n, jlu(*), ju(*)
c-----------------------------------------------------------------------
c
c Given a LU decomposition of a matrix stored in (alu, jlu, ju),
c this routine performs x = (LU)^{-T} y, i.e. LU transposed solve.
c 
c-----------------------------------------------------------------------
c local variables
c
      integer i,k
c
      do 10 i = 1, n
        x(i) = y(i)
   10 continue
c
c forward solve (with U^T)
c
      do 20 i = 1, n
        x(i) = x(i) * alu(i)
        do 30 k=ju(i),jlu(i+1)-1
          x(jlu(k)) = x(jlu(k)) - alu(k)* x(i)
   30   continue
   20 continue
c     
c     backward solve (with L^T)
c     
      do 40 i = n, 1, -1 
        do 50 k=jlu(i),ju(i)-1
          x(jlu(k)) = x(jlu(k)) - alu(k)*x(i)
   50   continue
   40 continue
c
      return
      end
