      subroutine arinde(nlist,nnode,nnodt,nelem,npoin,ndofn,ntotv,
     .                  ncoef,nzeco,liste,lnods,lpntn,touch,roffs,
     .                  apcol,izeco,itotv,nnodw,iblok)
c************************************************************************
c                 
c**** This routine constructs the arrays of indexes for a matrix A.
c**** These are organized as follows (CSR format):
c      
c**** ROFFS(ITOTV) = coefficient of A where eqn. ITOTV starts,
c**** APCOL(IZECO) = column of the IZECO coefficient of matrix A.
c                 
c************************************************************************
      implicit none
      integer   nlist,nnode,nnodt,nelem,npoin,ndofn,ntotv,
     .          ncoef,nzeco,ilist,ielem,jnode,jpoin,jposi,
     .          jdofn,jtotv,izeco,itotv,iblok,jtotn,klist,
     .          knode,kelem,kpoin,kposi,nnodw
      integer   liste(nlist),   lnods(nnodt,nelem), lpntn(ntotv),
     .          roffs(ntotv+1), apcol(nzeco)
      logical*1 touch(ncoef)

      roffs(itotv)=izeco
      do ilist=1,nlist
        ielem=liste(ilist)
c
c***  Columns for main degrees of freedom
c        
        do jnode=1,nnode
          jpoin=lnods(jnode,ielem)
          if(jpoin.gt.0) then
            jposi=(ilist-1)*nnodw+jnode
            if(.not.touch(jposi)) then
              do klist=1,nlist
                kelem=liste(klist)
                do knode=1,nnode
                  kpoin=lnods(knode,kelem)
                  if(kpoin.eq.jpoin) then
                    kposi=(klist-1)*nnodw+knode
                    touch(kposi)=.true.
                  end if
                end do
              end do
              do jdofn=1,ndofn
                jtotv=(jpoin-1)*ndofn+jdofn
                jtotn=lpntn(jtotv)
                if(((iblok.eq.1).and.(jtotn.gt.0))) then
                  apcol(izeco)=jtotn
                  izeco=izeco+1
                else if (((iblok.eq.2).and.(jtotn.lt.0))) then
                  apcol(izeco)=jtotv
                  izeco=izeco+1
                end if
              end do
            end if
          end if
        end do
c
c*** Columns for the Lagrange multiplier (it can not appear in A_p)
c
        if((iblok.eq.1).and.(nnodw.gt.nnode)) then
          do jnode=nnode+1,nnodw
            jpoin=lnods(jnode,ielem)
            if(jpoin.gt.0) then
              jposi=(ilist-1)*nnodw+jnode
              if(.not.touch(jposi)) then
                do klist=1,nlist
                  kelem=liste(klist)
                  do knode=nnode+1,nnodw
                    kpoin=lnods(knode,kelem)
                    if(kpoin.eq.jpoin) then
                      kposi=(klist-1)*nnodw+knode
                      touch(kposi)=.true.
                    end if
                  end do
                end do
                jtotv=(ndofn-1)*npoin+jpoin
                jtotn=lpntn(jtotv)
                if(jtotn.gt.0) then
                  apcol(izeco)=jtotn
                  izeco=izeco+1
                end if
              end if
            end if
          end do
        end if
      end do

      roffs(ntotv+1)=nzeco+1

      end
