      subroutine delmem(iprob,nelem)
c**********************************************************************
c                 
c**** This routine deallocates the permanent memory for problem IPROB
c                 
c**********************************************************************
      implicit none
      include  'MatMan.h'
      integer   iprob,nelem,eamat,ielem
c
c***  Delete memory for element matrices when SOFAM = 2
c      
      if(sofam(iprob).eq.2) then
        call spoias(%val(iamat+(iprob-1)*lengp),eamat)
        do ielem = 1,nelem
          call delpoi(%val(eamat+(ielem-1)*lengp))
        end do
      end if
c
c***  Delete the rest of permanent memory
c      
      call delpoi(%val(iamat+(iprob-1)*lengp))
      call delpoi(%val(incol+(iprob-1)*lengp))
      call delpoi(%val(inrow+(iprob-1)*lengp))
      call delpoi(%val(ialpn+(iprob-1)*lengp))
      call delpoi(%val(ialpo+(iprob-1)*lengp))
      call delpoi(%val(iapma+(iprob-1)*lengp))
      call delpoi(%val(iapii+(iprob-1)*lengp))
      call delpoi(%val(iapij+(iprob-1)*lengp))
      call delpoi(%val(iafij+(iprob-1)*lengp))
      call delpoi(%val(irhsx+(iprob-1)*lengp))
c
c***  Re-initialize parameters
c      
      call slvecz(mprob,nband)
      call slvecz(mprob,nonze)
      call slvecz(mprob,nmult)
      call slvecz(mprob,svome) 
      call slvecz(mprob,speme)
      call slvecz(mprob,nzecp)
      call slvecz(mprob,nzecf)
      call slvecz(mprob,sizms)
      call slvecz(mprob,nequa)
      call slvecz(mprob,kmadi)

      end

      subroutine delpoi(point)
      integer point                                         ! pointer
      integer idumy
      if(point.gt.0) then
        call sadmem(2,point,idumy,idumy)
        point = 0
      end if

      end

