      subroutine elepoi(
     .  nelem,nnodw,nnodt,npoit,lengp,lnods,svomt,
     .  p_nepoi,p_lelpo,itask)
c**********************************************************************
c                 
c**** This routine constructs the list of elements to which the nodal
c**** points belong      
c                 
c**********************************************************************
      implicit none
      integer nelem,nnodt,npoit,lengp,lbyts,ielem,ipoin,
     .        inode,nlist,svomt,nnodw,itask
      integer lnods(nnodt,nelem)
      integer p_lelpo,p_nepoi,iadd1,iadd2                   ! pointer
c
c*** Construct the array NEPOI (number of elements per node) and allocate
c*** memory for the list
c
      lbyts=lengp*npoit
      if(itask.eq.1) then                                   ! Allocate
        call sadmem(0,p_nepoi,lbyts,svomt)                  ! N. of elements
        call sadmem(0,p_lelpo,lbyts,svomt)                  ! Adresses 
        call nelepo(p_lelpo,%val(p_nepoi),lnods,nelem,
     .              nnodw,nnodt,npoit,lengp,svomt,itask)
      else if(itask.eq.2) then                              ! Deallocate
        call nelepo(p_lelpo,%val(p_nepoi),lnods,nelem,
     .              nnodw,nnodt,npoit,lengp,svomt,itask)
        call sadmem(2,p_nepoi,lbyts,svomt)   
        call sadmem(2,p_lelpo,lbyts,svomt)   
      end if
      if(itask.eq.2) return
c
c*** Construct the list
c
      do ielem=1,nelem
        do inode=1,nnodw
          ipoin=lnods(inode,ielem)
          if(ipoin.gt.0) then
            call idenum(%val(p_nepoi),npoit,ipoin,nlist)
            iadd1=p_lelpo+(ipoin-1)*lengp
            call spoias(%val(iadd1),iadd2)
            call filnum(%val(iadd2),nlist,ielem)
          end if
        end do
      end do

      end
