      subroutine memmat(
     .  lnods,ndofn,nnode,nnodt,nnodw,nelem,
     .  npoin,ntotv,nsist,kimpo,iprob)
c**********************************************************************
c                 
c**** This routine allocates memory for the matrix of problem IPROB
c                 
c**********************************************************************
      implicit none
      include 'MatMan.h'
      integer
     .  p_mat,p_lpn,p_lpo,p_rhs,p_row,p_col,p_tem           ! pointer
      integer
     .  ndofn,nnode,nnodt,nnodw,nelem,npoin,ntotv,
     .  iprob,ndimt,kimpo,nsist,svomt,inode,ielem,
     .  lbyts,losiz
      integer      lnods(nnodt,nelem)
      character*50 solty
      data         svomt/0/
      save         svomt
c
c*** Write permanent memory information
c
      if(sofam(iprob).eq.1) then
        if(kites(iprob).eq.11) then
          if(kmsip(iprob).eq.0) then
            solty='  LDU (BANDED STORAGE)'
          else if(kmsip(iprob).eq.1) then
            solty=' LDU (SKYLINE STORAGE)'
          else
            call srunen(
     .        'MEMMAT: PIVOTING NOT AVAILABLE',lusol)
          end if
        else if(kites(iprob).eq.12) then
          if(kmsip(iprob).eq.2) then
            solty='  LDU (SPARSE STORAGE)'
          else
            call srunen(
     .        'MEMMAT: ONLY PIVOTING AVAILABLE',lusol)
          end if
        else
          call srunen('MEMMAT: WRONG SOLVER TYPE',lusol)
        end if
      else if(sofam(iprob).eq.2) then
        nequa(iprob)=ntotv
        if(kites(iprob).eq.21) then
          solty=' EE_CG METHOD'
        else if(kites(iprob).eq.22) then
          solty=' EE_GMRES METHOD'
        else
          call srunen('MEMMAT: WRONG SOLVER TYPE',lusol)
        end if
        if(kmsip(iprob).eq.-2) then
          solty = solty//' (DIAG. PREC.)'
        end if
      else if(sofam(iprob).eq.3) then
        if(kites(iprob).eq.31) then
          solty=' SK_CG METHOD'
        else if(kites(iprob).eq.32) then
          solty=' SK_CGNR METHOD'
        else if(kites(iprob).eq.33) then
          solty=' SK_BCG METHOD'
        else if(kites(iprob).eq.34) then
          solty=' SK_DBCG METHOD'
        else if(kites(iprob).eq.35) then
          solty=' SK_BCGSTAB METHOD'
        else if(kites(iprob).eq.36) then
          solty=' SK_TFQMR METHOD'
        else if(kites(iprob).eq.37) then
          solty=' SK_FOM METHOD'
        else if(kites(iprob).eq.38) then
          solty=' SK_GMRES METHOD'
        else if(kites(iprob).eq.39) then
          solty=' SK_FGMRES METHOD'
        else if(kites(iprob).eq.40) then
          solty=' SK_DQGMRES METHOD'
        else
          call srunen('MEMMAT: WRONG SOLVER TYPE',lusol)
        end if
        if(kmsip(iprob).eq.1) then
          solty = solty//' (DIAG. PREC.)'
        else if(kmsip(iprob).eq.2) then
          solty = solty//' (L_ILUT PREC.)'
        else if(kmsip(iprob).eq.3) then
          solty = solty//' (R_ILUT PREC.)'
        else if(kmsip(iprob).eq.4) then
          solty = solty//' (L_R_ILUT PREC.)'
        end if
      else
        call srunen('MEMMAT: WRONG SOLVER TYPE',lusol)
      end if
      
      write(lusol,900)
     .  wosol(iprob),solty,ntotv,nequa(iprob)
      if(kkryl(iprob).gt.0) write(lusol,910) kkryl(iprob)
      call spoias(%val(ialpn+(iprob-1)*lengp),p_lpn)

      if(sofam(iprob).eq.1) then
c
c*** Band matrix storage for direct solvers
c
        if(kmsip(iprob).eq.0) then
          call mameba(
     .      lnods,%val(p_lpn),ndofn,nnode,nnodt,
     .      nnodw,nelem,npoin,ntotv,nequa(iprob),
     .      ksymm(iprob),nband(iprob),iamat,iprob,
     .      lengp,ndimt,speme(iprob),sizms(iprob),
     .      lusol)
          kmadi(iprob)=ndimt
c
c*** Profile matrix storage for direct solvers
c
        else if(kmsip(iprob).eq.1) then
          call spoias(%val(ialpo+(iprob-1)*lengp),p_lpo)
          call mamepr(
     .      %val(p_lpo),nequa(iprob),ntotv,ksymm(iprob),
     .      ndimt,iamat,iprob,lengp,speme(iprob),
     .      sizms(iprob),lusol)
          kmadi(iprob)=ndimt
c
c*** Sparse matrix storage for direct solvers. The same routine as for the
c*** case of a banded storage is employed
c
        else if(kmsip(iprob).eq.2) then
          call mameba(
     .      lnods,%val(p_lpn),ndofn,nnode,nnodt,
     .      nnodw,nelem,npoin,ntotv,nequa(iprob),
     .      ksymm(iprob),nband(iprob),iamat,iprob,
     .      lengp,ndimt,speme(iprob),sizms(iprob),
     .      lusol)
          kmadi(iprob)=ndimt
        end if
c
c*** Store the vector of pointers to elemental matrices for EE iterative solvers
c
      else if(sofam(iprob).eq.2) then
        lbyts = lengp*(nelem+1)
        call sadmem(0,p_mat,lbyts,speme(iprob))
        call spoias(p_mat,%val(iamat+(iprob-1)*lengp))
        call mamelm(
     .    p_mat,ksymm(iprob),nnode,nnodw,ndofn,nelem,
     .    lusol,lengp,speme(iprob))
        kmadi(iprob)=1
      else if(sofam(iprob).eq.3) then
c
c*** Memory allocation for the sparse matrix used in SK iterative solvers
c
        call memdof(
     .    nnode,nnodt,nelem,npoin,ndofn,ntotv,
     .    %val(p_lpn),lnods,svomt,svome(iprob),
     .    speme(iprob),sizms(iprob),lengp,   1,
     .    nzecf(iprob),p_mat,p_row,p_col)
        lbyts = lengp*ntotv
        call sadmem(0,p_tem,lbyts,svomt)
        call ordspa(%val(p_row),%val(p_lpn),%val(p_tem),ntotv,
     .              nequa(iprob),nzecf(iprob))
        svome(iprob) = max(svome(iprob),svomt)
        call sadmem(2,p_tem,lbyts,svomt)
        call spoias(p_mat,%val(iamat+(iprob-1)*lengp))
        call spoias(p_row,%val(iafii+(iprob-1)*lengp))
        call spoias(p_col,%val(iafij+(iprob-1)*lengp))
        kmadi(iprob)=1
        write(lusol,911) nzecf(iprob)
      end if
c
c*** Allocate memory for the terms of the matrix corresponding to the
c*** prescribed degrees of freedom (only for direct and SK iterative solvers)
c
      if(((sofam(iprob).eq.1).or.(sofam(iprob).eq.3))
     .  .and.(kimpo.ne.0)) then
        if(nequa(iprob).lt.ntotv) then
          lbyts = 8*nsist*ntotv
          losiz = 0
          call sadmem(0,p_rhs,lbyts,speme(iprob))
          call spoias(p_rhs,%val(irhsx+(iprob-1)*lengp))
          call memdof(
     .      nnode,nnodt,nelem,npoin,ndofn,ntotv,
     .      %val(p_lpn),lnods,svomt,svome(iprob),
     .      speme(iprob),losiz,lengp,   2,
     .      nzecp(iprob),p_mat,p_row,p_col)
          call spoias(p_mat,%val(iapma+(iprob-1)*lengp))
          call spoias(p_row,%val(iapii+(iprob-1)*lengp))
          call spoias(p_col,%val(iapij+(iprob-1)*lengp))
        end if
c
c*** For EE iterative solvers, allocate memory only for the product A x_p
c*** (A is not explicitly built up)        
c
      else if((sofam(iprob).eq.2).and.(kimpo.ne.0)) then
        lbyts = 8*nsist*ntotv
        call sadmem(0,p_rhs,lbyts,speme(iprob))
        call spoias(p_rhs,%val(irhsx+(iprob-1)*lengp))
      end if
c
c*** Update volatile memory and write permanent memory 
c
      write(lusol,920) speme(iprob)
c
c*** If there are negative values in LNODS, change their sign
c
      if(conde(iprob)) then
        do ielem=1,nelem
          do inode=1,nnodt
            lnods(inode,ielem)=abs(lnods(inode,ielem))
          end do
        end do
      end if
c
c*** Formats
c      
  900 format(//,5x,67('#'),//,5x,
     .  '>>>> PERMANENT MEMORY INFORMATION FOR:  ',a15,/,5x,
     .  '     --------------------------------   ',//,
     .       11x,'*** SOLVER TYPE                 :',a35,/,     
     .       11x,'*** NUMBER OF D.O.F.            :',i10,/,
     .       11x,'*** NUMBER OF EQUATIONS         :',i10)
  910 format(11x,'*** KRYLOV DIMENSION            :',i10)
  911 format(11x,'*** NONZERO MATRIX COEFFICIENTS :',i10)
  920 format(11x,'*** TOTAL PERMANENT MEMORY      :',i10,' (BYTES)')

      end
