      subroutine nzecoe(nlist,nnode,nnodt,nelem,npoin,ndofn,
     .                  ntotv,ncoef,nzeco,liste,lnods,lpntn,
     .                  touch,nnodw,iblok)
c************************************************************************
c                 
c**** This routine computes the number of non-zero coefficients of a
c**** matrix A stored in compressed sparse row (CSR) format 
c                 
c************************************************************************
      implicit none
      integer   nlist,nnode,nnodt,nelem,npoin,ndofn,ntotv,
     .          ncoef,nzeco,iblok,ilist,ielem,jnode,jpoin,
     .          jposi,jdofn,jtotv,jtotn,klist,kelem,knode,
     .          kpoin,kposi,nnodw
      integer   liste(nlist), lnods(nnodt,nelem), lpntn(ntotv)
      logical*1 touch(ncoef)
      
      do ilist=1,nlist
        ielem=liste(ilist)
c
c***  Columns for main degrees of freedom
c        
        do jnode=1,nnode
          jpoin=lnods(jnode,ielem)
          if(jpoin.gt.0) then
            jposi=(ilist-1)*nnodw+jnode
            if(.not.touch(jposi)) then
              do klist=1,nlist
                kelem=liste(klist)
                do knode=1,nnode
                  kpoin=lnods(knode,kelem)
                  if(kpoin.eq.jpoin) then
                    kposi=(klist-1)*nnodw+knode
                    touch(kposi)=.true.
                  end if 
                end do
              end do
              do jdofn=1,ndofn
                jtotv=(jpoin-1)*ndofn+jdofn
                jtotn=lpntn(jtotv)           
                if(  ((iblok.eq.1).and.(jtotn.gt.0)).       ! Free column
     .            or.((iblok.eq.2).and.(jtotn.lt.0)))       ! or prescribed
     .            nzeco=nzeco+1 
              end do
            end if
          end if
        end do
c
c*** Columns for the Lagrange multiplier (it can not appear in A_p)
c        
        if((iblok.eq.1).and.(nnodw.gt.nnode)) then
          do jnode=nnode+1,nnodw
            jpoin=lnods(jnode,ielem)
            if(jpoin.gt.0) then
              jposi=(ilist-1)*nnodw+jnode
              if(.not.touch(jposi)) then
                do klist=1,nlist
                  kelem=liste(klist)
                  do knode=nnode+1,nnodw
                    kpoin=lnods(knode,kelem)
                    if(kpoin.eq.jpoin) then
                      kposi=(klist-1)*nnodw+knode
                      touch(kposi)=.true.
                    end if 
                  end do
                end do
                jtotv=(ndofn-1)*npoin+jpoin
                jtotn=lpntn(jtotv)
                if(jtotn.gt.0) nzeco = nzeco+1 
              end if
            end if
          end do
        end if
      end do

      end
