      subroutine ordspa(roffs,lpntn,newof,ntotv,nequa,nzeco)
c*************************************************************************
c                 
c**** This routine orders the array ROFFS used for sparse matrix storage 
c**** to account for the prescribed degrees of freedom. Recall that, 
c**** originally,
c      
c**** ROFFS(ITOTV) = coefficient of A where eqn. ITOTV starts
c
c**** WARNING: Renumbering is NOT possible using a profile matrix storage
c****          due to the fact that the arrays ROFFS and ACOLU in MEMDOF
c****          are computed using the consecutive order of the original
c****          numbering. This is used in particular to compute in diffe-
c****          rent routines the first and last elements of a row IROWS,
c****          which are ROFFS(IROWS) and ROFFS(IROWS+1)-1.
c                 
c*************************************************************************
      implicit none
      integer  ntotv,itotv,itotn,nequa,nzeco
      integer  roffs(ntotv+1),lpntn(ntotv),newof(ntotv)

      do itotv=1,ntotv
        newof(itotv)=0
      end do
      do itotv=1,ntotv
        itotn=lpntn(itotv)
        if(itotn.gt.0) newof(itotn) = roffs(itotv)
      end do
      do itotv=1,ntotv
        roffs(itotv)=newof(itotv)
      end do

      roffs(nequa+1)=nzeco+1

      end
