      subroutine condco(lpoin,lwork,lpote,npoit,npowt)
c*************************************************************************
c                 
c**** This routine performs the composition LWORK^-1(LPOIN(*)), where 
c**** LWORK is the first renumbering done to avoid condensed nodes in 
c**** the list of nodal points      
c
c*************************************************************************
      implicit none
      integer   npoit,npowt,ipoin,jpoin
      integer   lpote(npoit),lwork(npoit),lpoin(npoit)
c
c*** Inverse of LWORK stored in LPOTE
c
      do ipoin=1,npoit
        jpoin=lwork(ipoin)
        if(jpoin.gt.0) then
          lpote( jpoin)= ipoin
        else if(jpoin.lt.0) then
          lpote(-jpoin)=-ipoin
        end if
      end do
c
c*** Composition LPOTE(LPOIN(*)), using LWORK as bridge array
c
      do ipoin=1,npowt
        lwork(ipoin)=lpote(lpoin(ipoin))
      end do
      do ipoin=npowt+1,npoit
        lwork(ipoin)=lpote(ipoin)
      end do
      do ipoin=1,npoit
        lpoin(ipoin)=lwork(ipoin)
      end do

      end
