      subroutine condre(nnode,nnodt,nnodw,nelem,npoit,npoiw,
     .                  npows,lnods,lnodw,lwork)
c*************************************************************************
c                 
c**** This routine modifies array LNODS to deal with bubble condensation.
c**** It is assumed that nodes with condensed degrees of freedom are
c**** given with a negative value in the original array LNODS, although
c**** the output is again positive. 
c
c*************************************************************************
      implicit none
      integer   nnode,nnodt,nnodw,nelem,npoit,npoiw,npows,
     .          ielem,inode,jnode,ipoin,jpoin,npoib,icoun
      integer   lnods(nnodt,nelem), lnodw(nnodt,nelem),
     .          lwork(npoit)
c
c*** Store LNODS in LNODW and put negative nodes of LNODS at the end with
c*** value 0
c
      call slvecz(npoit,lwork)
      do ielem=1,nelem
        do inode=1,nnodw
          lnodw(inode,ielem)=lnods(inode,ielem)
        end do
        inode=0
        do while(inode.lt.nnodw)
          inode=inode+1
          ipoin=lnods(inode,ielem)
          if(ipoin.lt.0) then
            do jnode=inode+1,nnodw
              lnods(jnode-1,ielem)=lnods(jnode,ielem)
            end do
            lwork(-ipoin)=ipoin
            lnods(nnodw,ielem)=0
            inode=inode-1
          end if
        end do
      end do
c
c*** Renumber of non-negative nodes 
c
      npoiw=0
      npows=0
      icoun=0
      do ielem=1,nelem
        do inode=1,nnodw
          ipoin=lnods(inode,ielem)
          if(ipoin.gt.0) then
            if(lwork(ipoin).eq.0) then
              if(inode.le.nnode) then
                npoiw=npoiw+1
              else if(inode.gt.nnode) then
                npows=npows+1
              end if
              icoun=icoun+1
              lwork(ipoin)=icoun
            end if
            lnods(inode,ielem)=lwork(ipoin)
          end if
        end do
      end do
c
c*** Give to negative (condensed) nodes the highest numbers in LWORK
c
      npoib=npoiw+npows
      do ipoin=1,npoit
        jpoin=lwork(ipoin)
        if(jpoin.lt.0) then
          npoib=npoib+1
          lwork(ipoin)=-npoib
        end if
      end do
      
      end
