      subroutine notodf(lpntn,lpoin,iffix,ndofn,npoin,npois,
     .                  nequa)
c**********************************************************************
c                 
c**** This routine sets up array LPNTN from the array LPOIN, which 
c**** only contains the renumber of the nodes, not of the degrees of 
c**** freedom. LPOIN(I) contains the old node I e.g. LPOIN(3)=5 means
c**** that the new node 3 was the old node 5.
c                 
c**********************************************************************
      implicit  none
      integer   ndofn,npoin,npois,nequa,ntota,ipoin,joldf,ioldf,
     .          npres,kpoin
      integer   lpntn(npoin*ndofn+npois), lpoin(npoin+npois),
     .          iffix(npoin*ndofn+npois)
c
c*** Initialization
c      
      nequa=0
      npres=0
      ntota=ndofn*npoin
      do ipoin=1,npoin+npois
        kpoin=lpoin(ipoin)
c
c*** Condensed secondary degrees of freedom
c        
        if (kpoin.lt.-npoin) then
          ioldf=ntota-kpoin-npoin
          lpntn(ioldf)=0
c
c*** Condensed degrees of freedom associated to main nodes
c        
        else if(kpoin.lt.0) then
          joldf=(-kpoin-1)*ndofn
          do ioldf=joldf+1,joldf+ndofn
            lpntn(ioldf)=0
          end do
c
c*** Renumbering of degrees of freedom associated to main nodes
c          
        else if (lpoin(ipoin).le.npoin) then 
          joldf=(lpoin(ipoin)-1)*ndofn
          do ioldf=joldf+1,joldf+ndofn
            if (iffix(ioldf).ne.1) then
              nequa=nequa+1
              lpntn(ioldf)=nequa
            else
              npres=npres-1
              lpntn(ioldf)=npres
            end if
          end do
c
c*** Renumbering of secondary degrees of freedom 
c          
        else if (lpoin(ipoin).gt.npoin) then
          ioldf=ntota+lpoin(ipoin)-npoin
          if (iffix(ioldf).ne.1) then
            nequa=nequa+1
            lpntn(ioldf)=nequa
          else
            npres=npres-1
            lpntn(ioldf)=npres
          end if
        end if
      end do

      end
      
