      subroutine renban(lnods,lpntn,lwork,iffix,nnodw,nnodt,
     .                  npoin,npoiw,npows,nelem,ndofn,npois,
     .                  ntotv,nequa,lures,krenu,lengp,conde,
     .                  svome,svomt)
c***************************************************************************
c
c*** This routine optimizes the bandwidth. LPOIN(I) contains the new node
c*** number for the old node I
c
c***************************************************************************
      implicit none
      integer   nnodw,nnodt,npoin,npoiw,npows,nelem,ndofn,
     .          npois,ntotv,nequa,lures,krenu,lengp,svome,
     .          svomt,npoit,ipoin,ielem,inode,mxele,mxcon,
     .          itota,nband
      integer   lnods(nnodt,nelem), lpntn(ntotv),
     .          lwork(npoin),       iffix(ntotv)
      integer   ipadd,iadr1,iadd1,iadd2,iadd3,iadd4,iadd5   ! pointer
      logical*1 conde
c
c*** If no renumbering is needed, set LPNTN = identity (with possibly
c*** negative values if there are condensed nodes)      
c      
      if (krenu.eq.0) then
        if(conde) then
          npoit=npoin+npois
          do ielem=1,nelem
            do inode=1,nnodt
              ipoin=lnods(inode,ielem)
              if(ipoin.ne.0) lpntn(abs(ipoin))=ipoin
            end do
          end do
        else
          do ipoin = 1,npoin
            lpntn(ipoin) = ipoin
          end do
        end if
        call sadmem(0,iadr1,lengp*npoit,svomt)              ! Memory for LPOIN
        call slveca(npoit,lpntn,%val(iadr1))
        call notodf(lpntn,%val(iadr1),iffix,ndofn,
     .              npoin,npois,nequa)
        svome = max(svome,svomt)
        call sadmem(2,iadr1,lengp*npoit,svomt)              ! Deallocate LPOIN
c
c*** Renumbering 
c
      else
        npoit=npoiw+npows
        call slvecz(npoit,lpntn)              ! Use LPNTN as an auxiliar vector
        do ielem=1,nelem                      ! to compute max. elements that
          do inode=1,nnodw                    ! a node belongs mxele
            ipoin=lnods(inode,ielem)
            if(ipoin.ne.0)
     .        lpntn(ipoin)=lpntn(ipoin)+1
          end do
        end do
        mxele=lpntn(1)
        do ipoin=2,npoiw+npows
          if (lpntn(ipoin).gt.mxele) mxele=lpntn(ipoin)
        end do
        mxcon=mxele*(nnodw-1)                 ! Max.of conectivities/node
        iadd1=0                               ! LPOIN(npoin+npois)
        iadd2=iadd1+(npoin+npois)*lengp       ! LCONE(npoiw+npows,mxcon)
        iadd3=iadd2+(npoiw+npows)*mxcon*lengp ! NUMCO(npoiw+npows)
        iadd4=iadd3+(npoiw+npows)*lengp       ! LOLNE(npoiw+npows)
        iadd5=iadd4+(npoiw+npows)*lengp       ! LNEOL(npoiw+npows)
        itota=iadd5+(npoiw+npows)*lengp
        call sadmem(0,ipadd,itota,svomt)      ! Allocate auxiliar memory
        call slvecz(itota/lengp,%val(ipadd))
        call setcon(lnods,%val(ipadd+iadd2),  ! Set conectivities NUMCO & LCONE
     .              %val(ipadd+iadd3),
     .              npoiw+npows,nnodt,nnodw,
     .              nelem,mxcon,nband)
        call optban(%val(ipadd+iadd1),        ! Optimizes bandwidth
     .              %val(ipadd+iadd2),
     .              %val(ipadd+iadd3),
     .              %val(ipadd+iadd4),
     .              %val(ipadd+iadd5),
     .              nnodt,nnodw,nelem,
     .              npoiw+npows,mxcon,nband)
        if(conde)
     .    call condco(%val(ipadd+iadd1),lwork,
     .                %val(ipadd+iadd2),npoin+npois,
     .                npoiw+npows)
        call notodf(lpntn,%val(ipadd+iadd1),
     .              iffix,ndofn,npoin,npois,
     .              nequa)
        svome = max(svome,svomt)
        call sadmem(2,ipadd,itota,svomt)      ! Deallocate auxiliar memory
      end if
      
      end
