      subroutine renum0(lnods,lpntn,lword,nelem,nnode,nnodt,npoin,
     .                  lures,iwork)
c**********************************************************************
c                 
c**** This routine sets up array LPNTN if node renumbering for
c**** profile minimization is desired
c                 
c**********************************************************************
      implicit real*8(a-h,o-z)
      integer   lnods(nnodt,nelem), lpntn(npoin), iwork(*)
      logical   stamp
c
c*** Computes the connections between degrees of freedom
c
      n1 = 1
      call renum1(lnods,iwork(n1),nnode,nnodt,npoin,
     .            nelem,nposi)
c
c*** Auxiliar memory for renumbering
c
      n2 = n1 + nposi          !  nodal connections
      n3 = n2 + npoin          !  nstart
      n4 = n3 + npoin - n1     !  level
      if(n4.gt.lword) then
        write(lures,900) n4, lword
        call srunen('RENUM0: INSUFFICIENT WORK SPACE',lures)
      end if
c
c*** Renumbering routines
c
      call renum2(iwork(n1),iwork(n2),iwork(n3),lpntn,npoin,ns)
      call renum3(iwork(n1),iwork(n2),iwork(n3),lpntn,npoin,ns)
c
c*** Obtain the inverse of array lpntn
c
      do ipoin=1,npoin
        iwork(lpntn(ipoin))=ipoin
      end do
c
c*** Print renumbered nodes
c
      stamp=.false.
      if(stamp) then
        write(lures,901)
        do ipoin=1,npoin
          write(lures,902) ipoin,lpntn(ipoin),ipoin,iwork(ipoin)
        end do
      end if

      do ipoin=1,npoin
        lpntn(ipoin)=iwork(ipoin)
      end do
c
c*** Formats
c
  900 format(//,5x,67('#'),//,5x,
     .  '>>>> RENUMBERING MODULE REQUIRES MORE WORKING SPACE:',/,
     .  11x,'*** NUMBER OF REQUIRED  INTEGERS :',i10,/,
     .  11x,'*** NUMBER OF ALLOCATED INTEGERS :',i10   )
  901 format(//,5x,67('#'),//,5x,
     .  '>>>> RENUMBERED NODES :',//,
     .  11x,'OLD',10x,'NEW',10x,'NEW',10x,'OLD',/)
  902 format( 11x,   i10,3x,   i10,3x,   i10,3x,i10)

      end
