      subroutine renum3(nadj,nact,noda,newnn,nodes,i)
c**********************************************************************
c
c**** Resequence nodes for minimum profile
c
c**********************************************************************
      implicit real*8 (a-h,o-z)
      integer   nadj(*),newnn(*),nact(*),noda(*)
 
      large = 5**5
c
c*** King's scheme
c
      do j = 1,nodes
        newnn(j) = 0
        noda(j) = 0
      end do
      newnn(i) = 1
      nac = 0
c
c*** Negate all ndeg entries for nodes which are
c*** adjacent to starting node i
c
      maxfrt = 0
      nad = nadj(i)
      do while (nad.gt.0)
        maxfrt = maxfrt + 1
        npj = nadj(nad)
        if(noda(npj).eq.0) then
          nac = nac + 1
          noda(npj) = nac
          nact(nac) = npj
        end if
        nad = nadj(nad+1)
      end do
      noda(i) = large
c
c*** Loop over nodes to be renumbered
c
      do k = 2,nodes
        minnew = large
        lmin = large
c
c*** Loop over active nodes
c*** Skip to next node if old node is already renumbered
c
        do iact = 1,nac
          j = nact(iact)
          if(newnn(j).le.0) then
            new = -1
            min = large
c
c*** Compute the increment in active nodes for each node j
c*** Compute when this node was first active by checking for renumbered
c*** neighbours with lowest numbers
c
            nad = nadj(j)
            do while (nad.gt.0)
              n = nadj(nad)
              if(noda(n).eq.0) new = new + 1
              if(newnn(n).ne.0) then
                if(newnn(n).lt.min)min = newnn(n)
              end if
              nad = nadj(nad+1)
            end do
c
c*** Select node with smallest increment in active nodes
c*** in the case of a tie, select node which has been longest active
c
            if(new.le.minnew) then
              if((new.ne.minnew).or.(min.lt.lmin)) then
                minnew = new
                lmin = min
                next = j
              end if
            end if
          end if
        end do
c
c*** Renumber node and compute number of active nodes
c
        newnn(next) = k
        nif = nif+minnew
        if(nif.gt.maxfrt) maxfrt = nif
c
c*** Set nodes which are adjacent to the node just renumbered
c*** as actives nodes, deactivate next
c
        npos = noda(next)
        ilast = nact(nac)
        noda(ilast) = npos
        nact(npos) = ilast
        nac = nac - 1

        if(minnew .ne. -1) then
          nad = iabs(nadj(next))
          do while (nad.gt.0)
            n = nadj(nad)
            if(noda(n).eq.0) then
              nac = nac + 1
              noda(n) = nac
              nact(nac) = n
            end if
            nad = nadj(nad+1)
          end do
        end if
      end do

      end
