      subroutine renumn(
     .  lnods,lpntn,lwork,iffix,nnode,nnodt,npoin,
     .  npoiw,npows,nelem,ndofn,npois,ntotv,nequa,
     .  lures,krenu,lengp,conde,svome,svomt)
c**********************************************************************
c                 
c**** This routine sets up array LPNTN. In this routine only the nodes
c**** are renumbered, so that the array LPNTN has the NDOFN components
c**** equal.
c                 
c**********************************************************************
      implicit  none
      integer   iadr1,iadr2                                 ! pointer
      integer
     .  nnode,nnodt,npoin,npoiw,npows,nelem,ndofn,
     .  npois,ntotv,nequa,lures,krenu,lengp,svome,
     .  svomt,lword,npoit,ipoin,lbytr,inode,ielem
      integer   lnods(nnodt,nelem), lpntn(ntotv),
     .          lwork(npoin),       iffix(ntotv)
      logical*1 conde
c
c*** If no renumbering is needed, set LPNTN = identity (with possibly
c*** negative values if there are condensed nodes)      
c      
      npoit=npoin+npois
      call sadmem(0,iadr1,lengp*npoit,svomt)                ! Memory for LPOIN
      if (krenu.eq.0) then
        if(conde) then
          npoit=npoin+npois
          do ielem=1,nelem
            do inode=1,nnodt
              ipoin=lnods(inode,ielem)
              if(ipoin.ne.0) lpntn(abs(ipoin))=ipoin
            end do
          end do
        else
          do ipoin = 1,npoin
            lpntn(ipoin) = ipoin
          end do
        end if
        call slveca(npoit,lpntn,%val(iadr1))
      end if

      if(krenu.eq.1) then
        npoit=npoiw+npows
c
c*** Node renumbering for profile minimization, only nodes are renumbered
c
        lword=(nnode*(nnode-1))*nelem*2+3*npoit+1
        lbytr=lengp*lword                                   ! Memory in bytes
        call sadmem(0,iadr2,lbytr,svomt)                    ! Allocate memory
        call renum0(lnods,%val(iadr1),lword,nelem,
     .              nnode,nnodt,npoit,lures,
     .              %val(iadr2))
        if(conde)
     .    call condco(%val(iadr1),lwork,%val(iadr2),
     .    npoin+npois,npoiw+npows)
        svome = max(svome,svomt)
        call sadmem(2,iadr2,lbytr,svomt)                    ! Deallocate memory
      end if
c
c*** Constructs the rest of components of LPNTN 
c
      call notodf(lpntn,%val(iadr1),iffix,ndofn,npoin,
     .            npois,nequa)
      svome = max(svome,svomt)
      call sadmem(2,iadr1,lengp*npoit,svomt)                ! Deallocate memory

      end
