      subroutine MatMan(
     .  lnods,iffix,rhsid,unkno,ndofn,nnode,nnodt,
     .  nnodw,nelem,npoin,ntotv,nsist,lures,kfact,
     .  kimpo,iprob,inte1,inte2,real1,itask)
c****************************************************************************
c
c**** This routine drives the library to deal with a linear system
c**** of equations. The tasks are:
c
c     itask = 1  Renumber of the equations
c     itask = 2  Memory allocation for the system matrix of problem IPROB      
c     itask = 3  Construction of the matrix
c     itask = 4  Solution of a linear system
c     itask = 5  Deallocate memory for problem IPROB
c
c     Ramon Codina
c     Last revision: March 1997 
c      
c****************************************************************************
      implicit   none
      include   'MatMan.h'
      integer
     .  ndofn,nnode,nnodt,nnodw,nelem,npoin,ntotv,
     .  lures,iprob,inte1,nsist,itask,kfact,kimpo
      real*8     timei,timef
      integer
     .  lnods(nnodt,nelem),   iffix(ntotv),
     .  inte2(*)
      real*8
     .  rhsid(ntotv,nsist),   unkno(ntotv,nsist),
     .  real1(*)
c
c***  Renumber
c      
      if(itask.eq.1) then
        lusol=lures                 
        call scputi(timei) 
        call renumb(
     .    lnods,iffix,nnode,nnodt,npoin,nelem,ndofn,
     .    ntotv,iprob)
        call scputi(timef)
        real1(1) = timef-timei 
c
c***  Memory allocation
c      
      else if(itask.eq.2) then
        if(nequa(iprob).gt.0) then
          lusol=lures                            
          call memmat(
     .      lnods,ndofn,nnode,nnodt,nnodw,nelem,
     .      npoin,ntotv,nsist,kimpo,iprob)
        end if
c
c***  Construction of matrices
c
      else if(itask.eq.3) then
        if(nequa(iprob).gt.0) then
          call builma(
     .      iprob,real1,inte1,inte2,nelem,ndofn,
     .      nnode,nnodw)
        end if
c
c***  Solution of the linear system
c
      else if(itask.eq.4) then
        if(nequa(iprob).gt.0) then
          lusol=lures                            
          call scputi(timei)
          call solsys(
     .      iffix,lnods,rhsid,unkno,ntotv,nelem,nnode,
     .      nnodt,nnodw,ndofn,npoin,nsist,kfact,iprob,
     .      inte1,inte2,timei)
          call scputi(timef)
          real1(1) = timef-timei
        end if                  
c
c***  Deallocate memory
c
      else if(itask.eq.5) then
        call delmem(iprob,nelem)
      else
        call srunen('MATMAN: WRONG TASK NUMBER',lures)
      end if

      end
